import maya.cmds as cmds
import maya.mel as mel



#Load in wesKeyEditor
from wesTools import wesKeyEditor
reload(wesKeyEditor)

#Load in wesScreenTracker
from wesTools import wesScreenTracker
reload(wesScreenTracker)


#Load in wesSceneSetup
from wesTools import wesSceneSetup
reload(wesSceneSetup)

#Load in finger select
#from wesTools import wesFingerSelect
#reload(wesFingerSelect)

#Load in wesOffsetAnim
from wesTools import wesOffsetAnim
reload(wesOffsetAnim)


#Load in wesRetime
from wesTools import wesRetime
reload(wesRetime)


#Load in wesImagePlanes
from wesTools import wesImagePlanes
reload(wesImagePlanes)

from wesTools.wesUtils import chosenModifiers

def UI():

	if cmds.dockControl("wesToolBarDock", exists=True):
		cmds.deleteUI("wesToolBarDock")

	if cmds.window("wesAnimToolsUI", exists=True, resizeToFitChildren=True):
		cmds.deleteUI("wesAnimToolsUI")
		# cmds.windowPref("wesAnimToolsUI", removeAll=True)

	user_width = 140
	user_height = 18

	#Create window interface
	wesAnimToolsUI = cmds.window('wesAnimToolsUI', title="wesAnimToolsUI", sizeable=True, width=user_width)
	
	#Choose either scrollLayout or rowColumnLayout
	#cmds.scrollLayout('wesLayout', height=650, width=user_width+23)
	cmds.rowColumnLayout('wesLayout')
	cmds.setParent('..')	
	cmds.showWindow(wesAnimToolsUI)


	##################Add Modules###################

	#SceneSetup Module
	wesSceneSetup.UI(parentWindow='wesLayout', user_width=user_width, user_height=user_height, frameClosed=False)

	#Screen Tracker Module
	wesScreenTracker.UI(parentWindow='wesLayout', user_width=user_width, user_height=user_height, frameClosed=False)

	#Finger Select
	#wesFingerSelect.UI(parentWindow='wesLayout', user_width=user_width, user_height=user_height, frameClosed=True)


	#wesOffsetAnim
	wesOffsetAnim.UI(parentWindow='wesLayout', user_width=user_width, user_height=user_height, frameClosed=True)


	#reTime module
	wesRetime.UI(parentWindow='wesLayout', user_width=user_width, user_height=user_height, frameClosed=True)


	#imageplane module
	wesImagePlanes.UI(parentWindow='wesLayout', user_width=user_width, user_height=user_height, frameClosed=True)

	#wesKeyEditor module
	wesKeyEditor.UI(parentWindow='wesLayout', user_width=user_width, user_height=user_height, frameClosed=False)

	#Dock the window
	#cmds.dockControl("wesToolBarDock", label="wesAnimTools", area="right", content=wesAnimToolsUI, allowedArea=['left', 'right'])
